<?php
	// variables
	$data	= array()	;
	$exchanged	= false	;
	$host	= "0.0.0.0"	;
	$mapping	= array()	;
	$name	= "metaSEC JDialog Websocket Server"	;
	$null	= NULL	;
	$pingTime	= date_create()	;
	$pingInterval	= 60	; // in seconds
	$port	= "33379"	;
	$transactions	= array()	;

	do_log(chr(1));
	set_mapping(array("0" => array("2", "3", "4", "5"), "1" => array("3", "4")));
	// create TCP/IP stream socket
	$socket = socket_create(AF_INET, SOCK_STREAM, SOL_TCP);
	// reuseable port
	socket_set_option($socket, SOL_SOCKET, SO_REUSEADDR, 1);
	// bind socket to specified port
	socket_bind($socket, 0, $port);
	//listen to socket
	socket_listen($socket);
	// create & add listning socket to the list
	$clients = array($socket);
	// start endless loop, so that our script doesn't stop
	while(true)
	{
		// manage multiple connections
		$changed = $clients;
		// returns the socket resources in $changed array
		socket_select($changed, $null, $null, 0, 10);
		// check for new socket
		if (in_array($socket, $changed))
		{
			// accpet new socket
			$socket_new = socket_accept($socket);
			do_log("connected", true, $socket_new);
			// add socket to client array
			$clients[] = $socket_new;
			// read data sent by the socket
			$header = socket_read($socket_new, 1024);
			// perform websocket handshake
			perform_handshaking($header, $socket_new, $host, $port);
			// add client data object
			$data[] = array("id" => null, "language" => null, "name" => null, "pingMessage" => null, "ponged" => true, "role" => null, "socket" => $socket_new, "status" => "initializing");
			// make room for new socket
			$found_socket = array_search($socket, $changed);
			unset($changed[$found_socket]);
		}
		// check for any incomming messages
		check_messages();
		// if its time to ping
		if(count($data) > 0 && abs(date_timestamp_get($pingTime) - date_timestamp_get(date_create())) >= $pingInterval)
		{
			do_log("connections: " . get_connections_count() . " | server: " . get_server_count() . " | clients: " . get_client_count());
			ping();
		}
		// if reload file exists
		/*if(file_exists("/tmp/james_lingo.restart"))
		{
			do_log("restarting", true);
			// delete file
			unlink("/tmp/james_lingo.restart");
			// close main socket
			socket_close($socket);
			// start new process of self
			exec('bash -c "exec nohup setsid screen -dmS james_lingo_websocket php ' . $_SERVER["SCRIPT_FILENAME"] . ' &> /dev/null &"');
			// exit
			exit();
		}*/
		usleep(10000);
	}
	// close the listening socket
	socket_close($socket);

	// add a new mapping
	function add_mapping($server, $client)
	{
		global $mapping;

		$client	= strval($client);
		$server	= strval($server);

		do_log("adding mapping: " . $server . " -> " . $client);
		if(!is_array($mapping[$server]))
		{
			$mapping[$server] = array();
		}
		$mapping[$server][] = $client;
	}
	// check if message has been sent and if so save it or pipe it
	function check_messages()
	{
		// globals
		global $data	;
		global $exchanged	;
		global $transactions	;
		// loop through data
		foreach($data as $index => &$clientData)
		{
			// peek at data
			$length = @socket_recv($clientData["socket"], $buffer, 4096, MSG_PEEK | MSG_DONTWAIT);
			if($length > 0)
			{
				$done = false;
				$message = "";
				$buffer = "";
				$iterations = 0;
				@socket_recv($clientData["socket"], $buffer, 1, MSG_DONTWAIT);
				// loop through data
				while(!$done)
				{
					$break_condition = array_search(true, array("iterations" => $iterations > 10000, "buffer" => strlen($buffer) > 4096));
					if($break_condition)
					{
						switch($break_condition)
						{
							case "buffer":
								do_log("message buffer size exceeded");
								break;
							case "iterations":
								do_log("message read iteration count exceeded");
								break;
						}
						disconnect("unreadable message");
						$message = "";
						$messageData = "";
						break;
					}
					// get single byte
					@socket_recv($clientData["socket"], $partialBuffer, 1, MSG_DONTWAIT);
					// add to message
					$buffer .= $partialBuffer;
					// unmask message
					$message = unmask($buffer);
					// if close message
					if($message == chr(3) . chr(233))
					{
						$done = true;
						disconnect($clientData["socket"]);
					}
					// if full json
					if(substr_count($message, "{") == substr_count($message, "}") && substr_count($message, "}") > 0)
					{
						// decode from json
						$messageData = json_decode($message, true);
						$done = true;
					}
					$iterations++;
				}
				if($message == chr(3) . chr(233))
				{
					continue;
				}
				do_log("sent message: \"" . addslashes($message). "\"", false, $clientData["socket"]);
				// if member type is set
				if(isset($messageData["type"]) && isset($messageData["value"]) && isset($messageData["id"]) && isset($messageData["acknowledge"]))
				{
					if(!isset($messageData["id"]) || ($clientData["id"] != null && $messageData["id"] !== $clientData["id"]))
					{
						// disconnect client
						disconnect($clientData["socket"], "id mismatch");
					}
					// check type
					switch($messageData["type"])
					{
						// if is id
						case "id":
							do_log("saving id");
							if(array_search($messageData["value"], array_column($data, "id")) !== false)
							{
								disconnect($clientData["socket"], "id already exists");
							}
							// save id
							$clientData["id"] = $messageData["value"];
							break;
						// if is language
						case "language":
							do_log("saving language");
							// save language
							$clientData["language"] = $messageData["value"];
							if(($clientData["role"] === "client" && $clientData["status"] === "ready"))
							{
								// exchange data
								exchange_data($clientData, "language");
							}
							break;
						// if is name
						case "name":
							do_log("saving name");
							$clientData["name"] = $messageData["value"];
							break;
						// if is ping
						case "ping":
							do_log("got ping, sending pong");
							send_message($clientData["socket"], json_encode(array("type" => "pong", "value" => $messageData["value"])));
							break;
						// if is pong
						case "pong":
							if($messageData["value"] === $clientData["pingMessage"])
							{
								do_log("acknowledged pong");
								// set has ponged
								$clientData["ponged"] = true;
							}
							else
							{
								// disconnect client
								disconnect($clientData["socket"], "ping message mismatch");
							}
							break;
						// if is role
						case "role":
								do_log("saving role");
								// save role
								$clientData["role"] = $messageData["value"];
							break;
						case "status":
							do_log("saving status");
							// save status
							$clientData["status"] = $messageData["value"];
							switch($messageData["value"])
							{
								case "active":
									if($clientData["role"] === "server")
									{
										// exchange data
										exchange_data($clientData, "connected");
									}
									break;
								case "exiting":
									// disconnect client
									disconnect($clientData["socket"]);
									break;
								case "inactive":
									if($clientData["role"] === "server")
									{
										// exchange data
										exchange_data($clientData, "disconnected");
									}
									break;
								case "paused":
									$transaction = &get_transaction_by_client($messageData["id"]);
									if($transaction != null)
									{
										$transaction["status"] = "paused";
									}
									break;
								case "ready":
									if($clientData["role"] === "client")
									{
										// exchange data
										exchange_data($clientData, "connected");
									}
									break;
							}
							break;
						case "transaction":
							$transaction = null;
							switch($messageData["value"])
							{
								case "accept":
									do_log("transaction got accepted");
									foreach(get_server_by_client($messageData["target"]) as $server)
									{
										if($server["id"] !== $messageData["id"])
										{
											send_message($server["socket"], json_encode(array("target" => $messageData["target"], "type" => "transaction", "value" => "accepted")));
										}
									}
									$transaction = &get_transaction_by_client($messageData["target"]);
									$transaction["server"] = $messageData["id"];
									$transaction["status"] = "ongoing";
									send_message(get_client_by_id($messageData["target"])["socket"], json_encode(array("type" => "transaction", "value" => "start")));
									break;
								case "end":
									do_log("ending transaction");
									if($messageData["target"] == null)
									{
										$transaction = &get_transaction_by_client($clientData["id"]);
										if($transaction != null)
										{
											$transaction["status"] = "done";
											if($transaction["server"] != null)
											{
												send_message(get_client_by_id($transaction["server"])["socket"], json_encode(array("target" => $clientData["id"], "type" => "transaction", "value" => "end")));
											}
										}
									}
									else
									{
										$transaction = &get_transaction_by_client($messageData["target"]);
										if($transaction != null && $transaction["server"] === $messageData["id"])
										{
											$transaction["status"] = "done";
											send_message(get_client_by_id($transaction["client"])["socket"], json_encode(array("type" => "transaction", "value" => "end")));
										}
									}
									break;
								case "start":
									do_log("starting transaction");
									$transactions[] = array("client" => $messageData["id"], "server" => null, "status" => "start");
									foreach(get_server_by_client($messageData["id"]) as $server)
									{
										send_message($server["socket"], json_encode(array("target" => $clientData["id"], "type" => "transaction", "value" => "start")));
									}
									break;
							}
							break;
						// if any other
						default:
							// pipe message
							do_log("piping message");
							if($messageData["target"] == null)
							{
								send_message(get_client_by_id(get_transaction_by_client($clientData["id"])["server"])["socket"], $message);
							}
							else
							{
								send_message($data[array_search($messageData["target"], array_column($data, "id"))]["socket"], $message);
							}
							break;
					}
					do_log("acknowledged message");
					send_message(get_client_by_id($messageData["id"])["socket"], json_encode(array("type" => "acknowledge", "value" => $messageData["acknowledge"])));
				}
				else
				{
					do_log("ignored message");
				}
			}
			elseif($length === false)
			{
				// get error
				$error = socket_last_error($clientData["socket"]);
				if($error != 11 && $error != 115)
				{
					do_log("Error: " . socket_strerror($error), false, $clientData["socket"]);
					disconnect($clientData["socket"], "connection lost");
				}
				else
				{
					// clear error
					socket_clear_error($clientData["socket"]);
				}
			}
		}
	}
	// disconnect client
	function disconnect($socket, $reason = "disconnected")
	{
		// globals
		global $clients	;
		global $data	;
		global $exchanged	;

		do_log("disconnected - reason: " . $reason, true, $socket);
		// disconnected client index
		$index = get_client_index_by_socket($socket);
		// reset language
		exchange_data($data[$index], "disconnected");
		if($data[$index]["role"] === "server")
		{
			$transactions = &get_transactions_by_server($data[$index]["id"]);
			if(count($transactions) > 0)
			{
				foreach($transactions as $index => &$transaction)
				{
					$transaction["status"] = "done";
				}
			}
		}
		else
		{
			$transaction = &get_transaction_by_client($data[$index]["id"]);
			if($transaction != null)
			{
				$transaction["status"] = "done";
			}
		}
		// remove client data
		unset($data[$index]);
		// resort data
		$data = array_values($data);
		// set to have not exchanged languages
		$exchanged = false;
		// remove client for $clients array
		unset($clients[array_search($socket, $clients)]);
		// resort clients
		$clients = array_values($clients);
		// close socket
		socket_close($socket);
	}
	// log messages
	function do_log($message, $syslog = false, $socket = NULL)
	{
		global $name;
		global $host;
		global $port;

		static $lines = 0;

		if($message == chr(1))
		{
			$lines = 0;
			do_log("\n");
			do_log($name);
			do_log("host: " . $host);
			do_log("port: " . $port);
			do_log("\n");
		}
		else
		{
			if($lines == 24)
			{
				do_log(chr(1));
			}
			if($message == "\n" && $syslog == false)
			{
				$message = str_pad($message, 80, "-", STR_PAD_LEFT);
			}
			elseif($socket != NULL)
			{
				@socket_getpeername($socket, $peerIp, $peerPort);
				$message = "[" . date("Y-m-d H:i:s") . "] <" . $peerIp . ":" . $peerPort . ">\t" . $message . "\n";
			}
			else
			{
				$message = "[" . date("Y-m-d H:i:s") . "]\t\t\t\t" . $message . "\n";
			}
			if($syslog)
			{
				syslog(LOG_DEBUG, "[" . $name . "]" . preg_replace("/\[[^\]]+\]/", "", $message));
			}
			print($message);
			$lines++;
		}
	}
	// send the laguage of the server to the clients and vice versa
	function exchange_data($client, $type)
	{
		// globals
		global $data	;
		global $transactions	;

		do_log("exchanging data");
		if($client["role"] === "server")
		{
			foreach(get_mapping($client["id"]) as $clientId)
			{
				$clientData	= get_client_by_id($clientId);
				if($clientData != null)
				{
					if($clientData["status"] === "paused" || count(get_server_by_client($clientId)) === 0)
					{
						send_message($clientData["socket"], json_encode(array("type" => "reload")));
					}
					else if($clientData["status"] === "ready")
					{
						$transaction	= get_transaction_by_client($clientId);
						switch($type)
						{
							case "connected":
							send_message($client["socket"], json_encode(array("type" => "client", "value" => array("id" => $clientData["id"], "name" => $clientData["name"], "language" => $clientData["language"]))));
							if($transaction != null && $transaction["status"] === "start")
							{
								send_message($client["socket"], json_encode(array("target" => $clientId, "type" => "transaction", "value" => "start")));
							}
							break;
							case "disconnected":
							send_message($clientData["socket"], json_encode(array("type" => "language", "value" => null)));
							break;
						}
					}
				}
			}
		}
		else
		{
			$server_list = get_server_by_client($client["id"]);
			if($type === "connected" && count($server_list) === 0)
			{
				send_message($client["socket"], json_encode(array("type" => "pause", "value" => "server")));
			}
			else
			{
				foreach($server_list as $server)
				{
					if($server["status"] === "active")
					{
						switch($type)
						{
							case "connected":
							send_message($server["socket"], json_encode(array("type" => "client", "value" => array("id" => $client["id"], "name" => $client["name"], "language" => $client["language"]))));
							break;
							case "disconnected":
							send_message($server["socket"], json_encode(array("type" => "client", "value" => $client["id"])));
							break;
							case "language":
							send_message($server["socket"], json_encode(array("target" => $client["id"], "type" => "language", "value" => $client["language"])));
							break;
						}
					}
				}
			}
		}
	}
	// get client in $data by id
	function &get_client_by_id($id)
	{
		global $data;

		$client	= null;
		$id	= strval($id);

		foreach($data as $index => &$clientData)
		{
			if($clientData["id"] === $id)
			{
				$client = $clientData;
				break;
			}
		}

		return $client;
	}
	// get number of clients
	function get_client_count()
	{
		global $data;

		return count(array_filter($data, function($clientData){return $clientData["role"] === "client";}));
	}
	// get client index in $data by socket
	function get_client_index_by_socket($socket)
	{
		// globals
		global $data;

		$index = null;
		// loop through data
		foreach($data as $userIndex => $userData)
		{
			// if sockets match
			if($socket === $userData["socket"])
			{
				// set the index
				$index = $userIndex;
				break;
			}
		}

		return $index;
	}
	// get number of connections
	function get_connections_count()
	{
		global $data;

		return count($data);
	}
	// get mapping
	function get_mapping($server = null, $client = null)
	{
		global $mapping;

		$client	= strval($client);
		$returnValue	= null;
		$server	= strval($server);
		$is_empty	= array("client" => $client == null, "server" => $server == null);

		if($is_empty["server"] && $is_empty["client"])
		{
			$returnValue = $mapping;
		}
		else if(!$is_empty["server"])
		{
			$returnValue = $mapping[$server];
		}
		else if(!$is_empty["client"])
		{
			$returnValue = array();
			foreach($mapping as $serverId => $clientIds)
			{
				if(is_mapped($serverId, $client))
				{
					$returnValue[] = $serverId;
				}
			}
		}

		return $returnValue;
	}
	// get server by client id
	function get_server_by_client($client)
	{
		$server	= array();
		$transaction	= get_transaction_by_client($client);

		if($transaction != null && $transaction["server"] != null)
		{
			$server[] = &get_client_by_id($transaction["server"]);
		}
		else
		{
			foreach(get_mapping(null, $client) as $serverId)
			{
				$current = &get_client_by_id($serverId);
				if($current != null && $current["status"] !== "inactive")
				{
					$server[] = $current;
				}
			}
		}

		return $server;
	}
	// get number of servers
	function get_server_count()
	{
		global $data;

		return count(array_filter($data, function($clientData){return $clientData["role"] === "server";}));
	}
	// get transaction by client id
	function &get_transaction_by_client($client)
	{
		global $transactions;

		$index = array_search(strval($client), array_column(array_reverse($transactions), "client"));
		if($index === false)
		{
			$returnValue = null;
		}
		else
		{
			$returnValue = &$transactions[count($transactions) - 1 - $index];
			if($returnValue["status"] === "done")
			{
				$returnValue = null;
			}
		}

		return $returnValue;
	}
	// get transactions by server id
	function &get_transactions_by_server($server)
	{
		global $transactions;

		$server = strval($server);
		$transaction_list = array();
		foreach(array_reverse($transactions) as $index => &$transaction)
		{
			if($transaction["server"] === $server && $transaction["status"] !== "done")
			{
				$transaction_list[] = &$transaction;
			}
		}

		return $transaction_list;
	}
	// if mapping exists
	function is_mapped($server, $client)
	{
		global $mapping;

		return in_array(strval($client), $mapping[strval($server)]);
	}
	// encode message for transfer to client.
	function mask($text)
	{
		$b1 = 0x80 | (0x1 & 0x0f);
		$length = strlen($text);
		if($length <= 125)
			$header = pack('CC', $b1, $length);
		elseif($length > 125 && $length < 65536)
			$header = pack('CCn', $b1, 126, $length);
		elseif($length >= 65536)
			$header = pack('CCNN', $b1, 127, $length);
		return $header.$text;
	}
	// handshake new client.
	function perform_handshaking($receved_header,$client_conn, $host, $port)
	{
		socket_getpeername($client_conn, $ip);
		$headers = array();
		$lines = preg_split("/\r\n/", $receved_header);
		foreach($lines as $line)
		{
			$line = chop($line);
			if(preg_match('/\A(\S+): (.*)\z/', $line, $matches))
			{
				$headers[$matches[1]] = $matches[2];
			}
		}
		$secKey = $headers['Sec-WebSocket-Key'];
		$secAccept = base64_encode(pack('H*', sha1($secKey . '258EAFA5-E914-47DA-95CA-C5AB0DC85B11')));
		//hand shaking header
		$upgrade  = "HTTP/1.1 101 Web Socket Protocol Handshake\r\n" .
		"Upgrade: websocket\r\n" .
		"Connection: Upgrade\r\n" .
		/*"WebSocket-Origin: $host\r\n" .
		"WebSocket-Location: ws://$host:$port/demo/shout.php\r\n".*/
		"Sec-WebSocket-Accept: $secAccept\r\n\r\n";
		socket_write($client_conn,$upgrade,strlen($upgrade));
	}
	// sends a ping to every client
	function ping()
	{
		//globals
		global $data;
		global $pingTime;

		do_log("pinging clients");
		// set ping time to current
		$pingTime = date_create();
		// loop through clients
		foreach($data as &$clientData)
		{
			// if previous ping has not been answered
			if($clientData["ponged"] === false)
			{
				// disconnect client
				disconnect($clientData["socket"], "no pong");
			}
			else
			{
				// set has not ponged back
				$clientData["ponged"]	= false;
				$message	= random_string(16);
				$clientData["pingMessage"]	= $message;
				// send ping
				send_message($clientData["socket"], json_encode(array("type" => "ping", "value" => $message)));
				//do_log("pinging: " . $clientData["name"] . " (ID: " . $clientData["id"] . ") - " . $message);
			}
		}
	}
	// creates a random alphanumeric string of given length
	function random_string($length)
	{
		$characters	= "0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ"	;
		$currentCharacter	= 0	;
		$string	= ""	;

		for($currentCharacter = 0; $currentCharacter < $length; $currentCharacter++)
		{
			$string .= $characters[rand(0, strlen($characters) - 1)];
		}

		return $string;
	}
	// remove mapping
	function remove_mapping($server, $client)
	{
		global $mapping;

		$client	= strval($client);
		$server	= strval($server);

		do_log("removing mapping: " . $server . " -> " . $client);
		if(is_mapped($server, $client))
		{
			array_splice($mapping[$server], array_search($client, $mapping[$server]), 1);
		}
	}
	// send message to clients
	function send_message($socket, $msg)
	{
		do_log("sending message: " . $msg);
		$msg = mask($msg);
		@socket_write($socket,$msg,strlen($msg));
	}
	// set mapping array
	function set_mapping($new_mapping)
	{
		global $mapping;

		do_log("setting mapping: " . json_encode($new_mapping));
		$mapping = $new_mapping;
	}
	// unmask incoming framed message
	function unmask($text)
	{
		$length = ord($text[1]) & 127;
		if($length == 126) {
			$masks = substr($text, 4, 4);
			$data = substr($text, 8);
		}
		elseif($length == 127) {
			$masks = substr($text, 10, 4);
			$data = substr($text, 14);
		}
		else {
			$masks = substr($text, 2, 4);
			$data = substr($text, 6);
		}
		$text = "";
		for ($i = 0; $i < strlen($data); ++$i) {
			$text .= $data[$i] ^ $masks[$i%4];
		}
		return $text;
	}

?>
